## s390-tools 1.37.0

=== Makefile ===
ARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)

# Include common definitions
include common.mak

LIB_DIRS = libvtoc libu2s libutil libzds libdasd libvmdump
TOOL_DIRS = zipl zdump fdasd dasdfmt dasdview tunedasd \
	   tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf \
	   vmconvert vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools \
	   ziomon iucvterm hyptop cmsfs-fuse qethqoat zfcpdump zdsfs cpumf \
	   systemd hmcdrvfs cpacfstats zdev dump2tar
SUB_DIRS = $(LIB_DIRS) $(TOOL_DIRS)

all: $(TOOL_DIRS)
clean: $(TOOL_DIRS)
install: $(TOOL_DIRS)

#
# For simple "make" we explicitly set the MAKECMDGOALS to "all".
#
ifeq ($(MAKECMDGOALS),)
MAKECMDGOALS = all
endif

#
# We have to build the libraries before the tools are built. Otherwise
# the tools would trigger parallel "make -C" builds for libraries in
# case of "make -j".
#
# MAKECMDGOALS contains the list of goals, e.g. "clean all". We use
# "foreach" to generate a ";" separated list of "make -C <target>".
# For example the the expansion for "make clean all" is:
#
# $(MAKE) -C $@ [..] clean ;  $(MAKE) -C $@ [...] all ;
#
# This ensures that the commandline targets are serialized and also "make -j"
# works as expected, e.g. "make clean all -j 20".
#

$(TOOL_DIRS): $(LIB_DIRS)
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) ARCH=$(ARCH) $(goal) ;)
.PHONY: $(TOOL_DIRS)

$(LIB_DIRS):
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) ARCH=$(ARCH) $(goal) ;)
.PHONY: $(LIB_DIRS)

=== cmsfs-fuse/Makefile ===
#!/usr/bin/make -f

include ../common.mak

ifeq (${HAVE_FUSE},0)

all:
	$(SKIP) HAVE_FUSE=0

install:
	$(SKIP) HAVE_FUSE=0

else

check_dep:
	$(call check_dep, \
		"cmsfs-fuse", \
		"fuse.h", \
		"fuse-devel", \
		"HAVE_FUSE=0")

ALL_CPPFLAGS += -I../include

all: check_dep cmsfs-fuse

ifneq ($(shell sh -c 'command -v pkg-config'),)
FUSE_CFLAGS = $(shell pkg-config --silence-errors --cflags fuse)
FUSE_LDLIBS = $(shell pkg-config --silence-errors --libs fuse)
else
FUSE_CFLAGS = -D_FILE_OFFSET_BITS=64 -I/usr/include/fuse
FUSE_LDLIBS = -lfuse
endif
ALL_CFLAGS += -DHAVE_SETXATTR $(FUSE_CFLAGS)
LDLIBS += $(FUSE_LDLIBS) -lm

OBJECTS = cmsfs-fuse.o dasd.o amap.o config.o

CMSFS_FUSE_DIR = $(SYSCONFDIR)/cmsfs-fuse
CONFIG_FILES = filetypes.conf

libs = $(rootdir)/libutil/libutil.a

cmsfs-fuse: $(OBJECTS) $(libs)

install: all
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 cmsfs-fuse \
		$(DESTDIR)$(USRBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 cmsfs-fuse.1 \
		$(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -g $(GROUP) -o $(OWNER) -d $(DESTDIR)$(CMSFS_FUSE_DIR)
	for cnf in $(CONFIG_FILES); do \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 etc/$$cnf $(DESTDIR)$(CMSFS_FUSE_DIR) ; \
	done

endif

clean:
	rm -f cmsfs-fuse *.o

.PHONY: all install clean check_dep

=== cpuplugd/Makefile ===
include ../common.mak

ALL_CFLAGS += -I../include

all: cpuplugd

LDLIBS += -lm

OBJECTS = daemon.o cpu.o info.o terms.o config.o main.o getopt.o mem.o

cpuplugd: $(OBJECTS)
	$(LINK) $(ALL_LDFLAGS) $^ $(LOADLIBES) $(LDLIBS) -o $@

clean:
	rm -f cpuplugd $(OBJECTS)

install: all
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 cpuplugd \
		$(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/cpuplugd.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/cpuplugd.conf.5 \
		$(DESTDIR)$(MANDIR)/man5

.PHONY: all install clean

=== dasdfmt/Makefile ===
include ../common.mak

ALL_CPPFLAGS += -I../include

all: dasdfmt

libs =	$(rootdir)/libdasd/libdasd.a \
	$(rootdir)/libvtoc/libvtoc.a \
	$(rootdir)/libu2s/libu2s.a \
	$(rootdir)/libutil/libutil.a

dasdfmt: dasdfmt.o $(libs)

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 dasdfmt $(DESTDIR)$(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 dasdfmt.8 \
		$(DESTDIR)$(MANDIR)/man8

clean:
	rm -f *.o *~ dasdfmt core

.PHONY: all install clean

=== dasdview/Makefile ===
include ../common.mak

ALL_CPPFLAGS += -I../include -DSYSFS

all: dasdview

libs =	$(rootdir)/libdasd/libdasd.a \
	$(rootdir)/libvtoc/libvtoc.a \
	$(rootdir)/libu2s/libu2s.a \
	$(rootdir)/libzds/libzds.a \
	$(rootdir)/libutil/libutil.a

dasdview: dasdview.o $(libs)

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 dasdview $(DESTDIR)$(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 dasdview.8 \
		$(DESTDIR)$(MANDIR)/man8

clean:
	rm -f *.o *~ dasdview core

.PHONY: all install clean

=== fdasd/Makefile ===
include ../common.mak

ALL_CPPFLAGS += -I../include

libs =	$(rootdir)/libvtoc/libvtoc.a \
	$(rootdir)/libzds/libzds.a \
	$(rootdir)/libdasd/libdasd.a \
	$(rootdir)/libu2s/libu2s.a

all: fdasd

fdasd: fdasd.o $(libs)

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 fdasd $(DESTDIR)$(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 fdasd.8 \
		$(DESTDIR)$(MANDIR)/man8

clean:
	rm -f *.o *~ fdasd core

.PHONY: all install clean

=== hmcdrvfs/Makefile ===
#!/usr/bin/make -f

include ../common.mak

ifeq (${HAVE_FUSE},0)

all:
	$(SKIP) HAVE_FUSE=0

install:
	$(SKIP) HAVE_FUSE=0

else

check_dep:
	$(call check_dep, \
		"hmcdrvfs", \
		"fuse.h", \
		"fuse-devel", \
		"HAVE_FUSE=0")

ifneq ($(shell sh -c 'command -v pkg-config'),)
FUSE_CFLAGS = $(shell pkg-config --silence-errors --cflags fuse)
FUSE_LDLIBS = $(shell pkg-config --silence-errors --libs fuse)
else
FUSE_CFLAGS = -D_FILE_OFFSET_BITS=64 -I/usr/include/fuse
FUSE_LDLIBS = -lfuse
endif
ALL_CPPFLAGS += -I../include
ALL_CFLAGS += -DFUSE_USE_VERSION=26 -D_LARGEFILE_SOURCE $(FUSE_CFLAGS)
LDLIBS += $(FUSE_LDLIBS) -lpthread -lrt -ldl -lm

OBJECTS = hmcdrvfs.o


all: check_dep hmcdrvfs

$(OBJECTS): Makefile

hmcdrvfs: $(OBJECTS)

install: all install-scripts
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 hmcdrvfs \
		$(DESTDIR)$(USRBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 hmcdrvfs.1 \
		$(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 lshmc.8 \
		$(DESTDIR)$(MANDIR)/man8

install-scripts: lshmc
	@for i in $^; do \
		cat $$i | \
		sed -e 's+%S390_TOOLS_VERSION%+$(S390_TOOLS_RELEASE)+' \
		>$(DESTDIR)$(USRSBINDIR)/$$i; \
		chown $(OWNER).$(GROUP) $(DESTDIR)$(USRSBINDIR)/$$i; \
		chmod 755 $(DESTDIR)$(USRSBINDIR)/$$i; \
	done

endif

clean:
	rm -f hmcdrvfs *.o

.PHONY: all install install-scripts clean check_dep

=== hyptop/Makefile ===
include ../common.mak

ifeq (${HAVE_NCURSES},0)

all:
	$(SKIP) HAVE_NCURSES=0

install:
	$(SKIP) HAVE_NCURSES=0

else

check_dep:
	$(call check_dep, \
		"hyptop", \
		"ncurses.h", \
		"ncurses-devel", \
		"HAVE_NCURSES=0")

ALL_CPPFLAGS += -I../include

LDLIBS += -lncurses

all: check_dep hyptop

OBJECTS = hyptop.o opts.o helper.o \
	  sd_core.o sd_sys_items.o sd_cpu_items.o \
	  tbox.o table.o table_col_unit.o \
	  dg_debugfs.o dg_debugfs_lpar.o dg_debugfs_vm.o dg_debugfs_vmd0c.o \
	  win_sys_list.o win_sys.o win_fields.o \
	  win_cpu_types.o win_help.o nav_desc.o

hyptop: $(OBJECTS) $(rootdir)/libutil/libutil.a

install: all
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 hyptop \
		$(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 hyptop.8 \
		$(DESTDIR)$(MANDIR)/man8

endif

clean:
	rm -f *.o *~ hyptop core

.PHONY: all install clean check_dep

=== ipl_tools/Makefile ===
include ../common.mak

ALL_CPPFLAGS += -I../include

all: chreipl lsreipl chshut lsshut

objects = main.o ccw.o fcp.o system.o shutdown.o \
	  cmd_lsshut.o cmd_chshut.o cmd_lsreipl.o cmd_chreipl.o proc.o

chreipl: $(objects)
	$(LINK) $(ALL_LDFLAGS) $^ $(LOADLIBES) $(LDLIBS) -o $@

lsreipl:
	ln -sf chreipl lsreipl

chshut:
	ln -sf chreipl chshut

lsshut:
	ln -sf chreipl lsshut

clean:
	rm -f *.o lsreipl chreipl chshut lsshut

install: all
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 chreipl \
		$(DESTDIR)$(USRSBINDIR)
	ln -f -s chreipl $(DESTDIR)$(USRSBINDIR)/lsreipl
	ln -f -s chreipl $(DESTDIR)$(USRSBINDIR)/chshut
	ln -f -s chreipl $(DESTDIR)$(USRSBINDIR)/lsshut
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/chreipl.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/lsreipl.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/lsshut.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/chshut.8 \
		$(DESTDIR)$(MANDIR)/man8

.PHONY: all install clean

=== libdasd/Makefile ===
include ../common.mak

ALL_CPPFLAGS += -I../include

lib = libdasd.a

all: $(lib)

objects = dasd_sys.o

$(lib): $(objects) Makefile

install: all

clean:
	rm -f *.o $(lib)

=== libu2s/Makefile ===
include ../common.mak

ALL_CPPFLAGS += -I../include

lib = libu2s.a

all: $(lib)

objects = u2s.o misc.o

$(lib): $(objects)

install: all

clean:
	rm -f *.o $(lib)

=== libutil/Makefile ===
include ../common.mak

ALL_CPPFLAGS += -I../include

lib = libutil.a

examples =	util_panic_example \
		util_path_example \
		util_scandir_example \
		util_file_example \
		util_libc_example \
		util_opt_example \
		util_prg_example \
		util_rec_example

all: $(lib) $(examples)

objects =	util_base.o \
		util_path.o \
		util_scandir.o \
		util_file.o \
		util_libc.o \
		util_list.o \
		util_opt.o \
		util_panic.o \
		util_part.o \
		util_prg.o \
		util_proc.o \
		util_rec.o

util_panic_example: util_panic_example.o $(rootdir)/libutil/libutil.a
util_path_example: util_path_example.o $(rootdir)/libutil/libutil.a
util_scandir_example: util_scandir_example.o $(rootdir)/libutil/libutil.a
util_file_example: util_file_example.o $(rootdir)/libutil/libutil.a
util_libc_example: util_libc_example.o $(rootdir)/libutil/libutil.a
util_opt_example: util_opt_example.o $(rootdir)/libutil/libutil.a
util_panic_example: util_panic_example.o $(rootdir)/libutil/libutil.a
util_prg_example: util_prg_example.o $(rootdir)/libutil/libutil.a
util_rec_example: util_rec_example.o $(rootdir)/libutil/libutil.a

$(lib): $(objects)

install: all

clean:
	rm -f *.o $(lib) $(examples)

=== debian/changelog ===
s390-tools (1.37.0-0ubuntu3) zesty; urgency=medium

  * Cherrypick v1.37.1 point release bug fixes LP: #1671497, LP: #1669785
    - dbginfo.sh: Add Docker debug data
    - lsdasd: Replace continue with return
    - lscss: Allow to specify devices from subchannel set 3
    - mon_fsstatd: Only use physical filesystems
    - mon_fsstatd: Fix double free in error path
    - mon_procd: Fix segmentation fault
    - mon_procd: Bump buffer size to 4096

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 27 Mar 2017 16:10:35 +0100

s390-tools (1.37.0-0ubuntu2) zesty; urgency=medium

  * chzdev/qeth: set bridge_role after the device is online to avoid a
    race condition when setting qeth attributes on boot. LP: #1618463.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 14 Mar 2017 09:26:12 +0000

s390-tools (1.37.0-0ubuntu1) zesty; urgency=medium

  * New upstream release LP: #1657166 LP: #1656809
  * Drop no-wait-for.patch, fixed upstream.
  * Reintroduce GNU_SOURCE and -rdynamic via dpkg-buildflags, as they are
    lost in the buildsystem.
  * Fix linking order in dump2tar Makefile.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 30 Jan 2017 12:37:45 +0000

s390-tools (1.36.1-1ubuntu1) zesty; urgency=medium

  * Merge s390-tools 1.36.1-1 from debian, remaining changes:
    - lower priority to optional
    - build-depend on libsnmp-dev
    - add cpuplugd, statd, osasnmpd subpackages
    - use z Systems branding in descriptions
    - ship monwriter
    - Apply patch to exit 0 on help for ziomon
    - Drop unused patches from debian/patches
    - Add CondifitionVirtualization to cpacfstatsd unit
    - Drop disable.patch
    - Drop WAIT_FOR stanzas in udev rules
    - Apply spelling patch
    - add update-initramfs -u zdev-root-update integration to zdev
    - Ship zdev in udeb
    - Add monitoring systemd units

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 30 Jan 2017 11:41:42 +0000

s390-tools (1.36.1-0ubuntu3) zesty; urgency=medium

  * Add update-initramfs -u integration for chzdev.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 14 Nov 2016 16:49:11 +0000

s390-tools (1.36.1-0ubuntu2) yakkety; urgency=medium

  * Fix exit codes. LP: #1616596

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 15 Sep 2016 13:05:09 +0100

s390-tools (1.36.1-0ubuntu1) yakkety; urgency=medium

  * New upstream point release. LP: #1609435

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 01 Sep 2016 18:04:11 +0100

s390-tools (1.36.0-0ubuntu1) yakkety; urgency=medium

  * New upstream release. LP: #1614579
  * Merge debian changes up to 1.34.0-2.
  * Refresh patches

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 24 Aug 2016 12:20:46 +0100

s390-tools (1.34.0-0ubuntu11) yakkety; urgency=medium

  * zipl: Import off-by-one patch to resolve failure to start subchannel
    in FBA loader. LP: #1592990.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 24 Jun 2016 12:41:30 +0100

s390-tools (1.34.0-0ubuntu10) yakkety; urgency=medium

  * Fix ts-shell maintainer scripts LP: #1567473:
    - create /var/log/ts-shell directory with the right permissions
    - remove errorous directory
  * Install iuctty-login@.service systemd unit, with a correct path LP:
    #1580226

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 06 Jun 2016 12:37:33 +0100

s390-tools (1.34.0-0ubuntu9) yakkety; urgency=medium

  * Cherrypick upstream fix for buffer overflow in dasdfmt. LP: #1582728

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 06 Jun 2016 11:51:16 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND=-D_GNU_SOURCE
export DEB_LDFLAGS_MAINT_APPEND=-rdynamic
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

options= V=1 HAVE_SNMP=1 SYSTEMDSYSTEMUNITDIR=/lib/systemd/system

%:
	dh $@ --parallel --with systemd

override_dh_install:
	# no dracut
	rm debian/tmp/lib/s390-tools/zdev-root-update
	chmod -x debian/tmp/etc/*/*.conf debian/tmp/lib/s390-tools/zfcpdump/zfcpdump_part.rd
	dh_install -ps390-tools-cpuplugd
	dh_install -ps390-tools-statd
	dh_install -ps390-tools-osasnmpd
	dh_install -Xcpuplugd -Xosasnmpd -Xprocd -Xfsstatd --fail-missing

override_dh_auto_clean:
	dh_auto_clean -- $(options)

override_dh_auto_build:
	dh_auto_build -- $(options)

override_dh_auto_install:
	dh_auto_install -- $(options)

## s390-tools 1.39.0

=== Makefile ===
--- 
+++ 
@@ -3,12 +3,12 @@
 # Include common definitions
 include common.mak
 
-LIB_DIRS = libvtoc libu2s libutil libzds libdasd libvmdump
+LIB_DIRS = libvtoc libu2s libutil libzds libdasd libvmdump libccw
 TOOL_DIRS = zipl zdump fdasd dasdfmt dasdview tunedasd \
 	   tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf \
 	   vmconvert vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools \
 	   ziomon iucvterm hyptop cmsfs-fuse qethqoat zfcpdump zdsfs cpumf \
-	   systemd hmcdrvfs cpacfstats zdev dump2tar
+	   systemd hmcdrvfs cpacfstats zdev dump2tar zkey
 SUB_DIRS = $(LIB_DIRS) $(TOOL_DIRS)
 
 all: $(TOOL_DIRS)

=== zkey/Makefile ===
include ../common.mak

CPPFLAGS += -I../include
LDFLAGS += -ldl

all: zkey

libs = $(rootdir)/libutil/libutil.a

zkey.o: zkey.c pkey.h misc.h

zkey: zkey.o $(libs)

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(USRBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 zkey $(DESTDIR)$(USRBINDIR)
	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -m 644 -c zkey.1 $(DESTDIR)$(MANDIR)/man1

clean:
	rm -f *.o zkey

.PHONY: all install clean

=== debian/changelog ===
s390-tools (1.39.0-0ubuntu4) artful; urgency=medium

  * Drop the depracated '-f device' and use required position 'device'
    only. -f flag got removed post v1.37. Otherwise zipl fails to
    determine correct underlying device topology and fails to IPL root on
    LVM or multipath. LP: #1723541

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 17 Oct 2017 18:09:49 +0100

s390-tools (1.39.0-0ubuntu3) artful; urgency=medium

  * Fix ftbfs.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 24 Aug 2017 00:14:43 +0100

s390-tools (1.39.0-0ubuntu1) artful; urgency=medium

  * New upstream release.
  * Drop patches applied upstream:
    + debian/patches/fix-ftbfs-link-order.patch
    + debian/patches/v1.37.1-updates.patch
  * Refresh patches.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 23 Aug 2017 17:28:21 +0100

s390-tools (1.37.0-0ubuntu7) artful; urgency=medium

  * Drop chmem/lsmem utilities, moved to util-linux.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 02 Aug 2017 16:59:54 +0300

s390-tools (1.37.0-0ubuntu6) artful; urgency=medium

  * Set cpi vars (system name, type, level and sysplex name) via systemd
    generator.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Jul 2017 12:41:57 +0100

s390-tools (1.37.0-0ubuntu5) artful; urgency=medium

  * Revert 1.37.0-0ubuntu2 "chzdev/qeth: set bridge_role after the device
    is online", as one must specify layer2 parameter when specifying layer
    specific parameters. LP: #1618463.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 24 May 2017 17:03:44 +0100

s390-tools (1.37.0-0ubuntu4) artful; urgency=medium

  * chzdev: Fix ineffective zfcp-lun udev rule preventing activation of
    unordered WWPNs. LP: #1683808

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 03 May 2017 12:25:08 +0100

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 override_dh_install:
 	# no dracut
-	rm debian/tmp/lib/s390-tools/zdev-root-update
+	rm -f debian/tmp/lib/s390-tools/zdev-root-update
 	chmod -x debian/tmp/etc/*/*.conf debian/tmp/lib/s390-tools/zfcpdump/zfcpdump_part.rd
 	dh_install -ps390-tools-cpuplugd
 	dh_install -ps390-tools-statd

## s390-tools 2.3.0

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 	   tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf \
 	   vmconvert vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools \
 	   ziomon iucvterm hyptop cmsfs-fuse qethqoat zfcpdump zdsfs cpumf \
-	   systemd hmcdrvfs cpacfstats zdev dump2tar zkey
+	   systemd hmcdrvfs cpacfstats zdev dump2tar zkey netboot etc
 SUB_DIRS = $(LIB_DIRS) $(TOOL_DIRS)
 
 all: $(TOOL_DIRS)

=== cpumf/Makefile ===
#!/usr/bin/make -f

include ../common.mak


CPUMF_DATADIR = $(TOOLS_DATADIR)/cpumf
DATA_FILES = cpum-cf-hw-counter.map \
	     cpum-cf-cfvn-1.ctr cpum-cf-cfvn-3.ctr \
	     cpum-cf-csvn-generic.ctr \
             cpum-cf-extended-z10.ctr cpum-cf-extended-z196.ctr \
	     cpum-cf-extended-zEC12.ctr cpum-sf-modes.ctr \
	     cpum-cf-extended-z13.ctr cpum-cf-extended-z14.ctr
LIB_FILES = bin/cpumf_helper
USRBIN_SCRIPTS = bin/lscpumf
USRSBIN_SCRIPTS = bin/chcpumf
MAN_FILES = lscpumf.1 chcpumf.8

all:

scripts: $(USRBIN_SCRIPTS) $(USRSBIN_SCRIPTS) $(LIB_FILES)
	chmod +x $(USRBIN_SCRIPTS) $(USRSBIN_SCRIPTS) $(LIB_FILES)

check:

install: scripts install-man
	for prg in $(USRBIN_SCRIPTS); do \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $$prg $(DESTDIR)$(USRBINDIR) ; \
	done
	for prg in $(USRSBIN_SCRIPTS); do \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $$prg $(DESTDIR)$(USRSBINDIR) ; \
	done
	test -d $(DESTDIR)$(CPUMF_DATADIR) || mkdir -p $(DESTDIR)$(CPUMF_DATADIR)
	for lib in $(LIB_FILES); do \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $$lib $(DESTDIR)$(TOOLS_LIBDIR) ; \
	done
	for data in $(DATA_FILES); do \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 data/$$data $(DESTDIR)$(CPUMF_DATADIR) ; \
	done

install-man:
	for man in $(MAN_FILES); do \
	  msection=`echo $$man |sed 's/.*\.\([1-9]\)$$/man\1/'` ; \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 -D man/$$man $(DESTDIR)$(MANDIR)/$$msection/$$man ; \
	done

man2pdf:
	for man in $(MAN_FILES); do \
	  man -t man/$$man |ps2pdf -sPAPERSIZE=a4 - man/$${man}.pdf ; \
	done
man2text:
	for man in $(MAN_FILES); do \
	  MANWIDTH=80 LANG=C man man/$$man |col -b |expand > man/$${man}.txt ; \
	done

clean:
	rm -f $(LIB_FILES) $(USRBIN_SCRIPTS) $(USRSBIN_SCRIPTS)

%: %.in
	real_libdir=$(TOOLS_LIBDIR); \
	real_cpumfdatadir=$(CPUMF_DATADIR); \
	$(SED) -e "s#@lib_path@#$$real_libdir#g" \
	       -e "s#@cpumfdata_path@#$$real_cpumfdatadir#g" \
	       -e 's#@S390_TOOLS_RELEASE@#$(S390_TOOLS_RELEASE)#g' \
	< $< > $@

.PHONY: all scripts install install-man man2pdf man2text clean

=== cpuplugd/Makefile ===
--- 
+++ 
@@ -1,6 +1,4 @@
 include ../common.mak
-
-ALL_CFLAGS += -I../include
 
 all: cpuplugd

=== dasdinfo/Makefile ===
include ../common.mak

libs = $(rootdir)/libu2s/libu2s.a \
       $(rootdir)/libutil/libutil.a \
       $(rootdir)/libdasd/libdasd.a

all: dasdinfo

dasdinfo: dasdinfo.o $(libs)

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 dasdinfo $(DESTDIR)$(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 dasdinfo.8 \
		$(DESTDIR)$(MANDIR)/man8

clean:
	rm -f *.o *~ dasdinfo core

.PHONY: all install clean

=== fdasd/Makefile ===
--- 
+++ 
@@ -1,11 +1,10 @@
 include ../common.mak
-
-ALL_CPPFLAGS += -I../include
 
 libs =	$(rootdir)/libvtoc/libvtoc.a \
 	$(rootdir)/libzds/libzds.a \
 	$(rootdir)/libdasd/libdasd.a \
-	$(rootdir)/libu2s/libu2s.a
+	$(rootdir)/libu2s/libu2s.a \
+	$(rootdir)/libutil/libutil.a
 
 all: fdasd

=== hmcdrvfs/Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 	$(call check_dep, \
 		"hmcdrvfs", \
 		"fuse.h", \
-		"fuse-devel", \
+		"fuse-devel or libfuse-dev", \
 		"HAVE_FUSE=0")
 
 ifneq ($(shell sh -c 'command -v pkg-config'),)
@@ -26,7 +26,6 @@
 FUSE_CFLAGS = -D_FILE_OFFSET_BITS=64 -I/usr/include/fuse
 FUSE_LDLIBS = -lfuse
 endif
-ALL_CPPFLAGS += -I../include
 ALL_CFLAGS += -DFUSE_USE_VERSION=26 -D_LARGEFILE_SOURCE $(FUSE_CFLAGS)
 LDLIBS += $(FUSE_LDLIBS) -lpthread -lrt -ldl -lm
 
@@ -50,7 +49,7 @@
 install-scripts: lshmc
 	@for i in $^; do \
 		cat $$i | \
-		sed -e 's+%S390_TOOLS_VERSION%+$(S390_TOOLS_RELEASE)+' \
+		sed -e 's/%S390_TOOLS_VERSION%/$(S390_TOOLS_RELEASE)/' \
 		>$(DESTDIR)$(USRSBINDIR)/$$i; \
 		chown $(OWNER).$(GROUP) $(DESTDIR)$(USRSBINDIR)/$$i; \
 		chmod 755 $(DESTDIR)$(USRSBINDIR)/$$i; \

=== ipl_tools/Makefile ===
--- 
+++ 
@@ -1,6 +1,4 @@
 include ../common.mak
-
-ALL_CPPFLAGS += -I../include
 
 all: chreipl lsreipl chshut lsshut

=== libu2s/Makefile ===
--- 
+++ 
@@ -1,6 +1,4 @@
 include ../common.mak
-
-ALL_CPPFLAGS += -I../include
 
 lib = libu2s.a

=== libutil/Makefile ===
include ../common.mak

lib = libutil.a

examples =	util_base_example \
		util_panic_example \
		util_path_example \
		util_scandir_example \
		util_file_example \
		util_libc_example \
		util_opt_example \
		util_opt_command_example \
		util_prg_example \
		util_rec_example

all: $(lib) $(examples)

objects =	util_base.o \
		util_path.o \
		util_scandir.o \
		util_file.o \
		util_libc.o \
		util_list.o \
		util_opt.o \
		util_panic.o \
		util_part.o \
		util_prg.o \
		util_proc.o \
		util_rec.o

util_base_example: util_base_example.o $(lib)
util_panic_example: util_panic_example.o $(lib)
util_path_example: util_path_example.o $(lib)
util_scandir_example: util_scandir_example.o $(lib)
util_file_example: util_file_example.o $(lib)
util_libc_example: util_libc_example.o $(lib)
util_opt_example: util_opt_example.o $(lib)
util_opt_command_example: util_opt_command_example.o $(lib)
util_panic_example: util_panic_example.o $(lib)
util_prg_example: util_prg_example.o $(lib)
util_rec_example: util_rec_example.o $(lib)

$(lib): $(objects)

install: all

clean:
	rm -f *.o $(lib) $(examples)

=== mon_tools/Makefile ===
include ../common.mak

all: mon_fsstatd mon_procd

mon_fsstatd: mon_fsstatd.o

mon_procd: mon_procd.o

install: all
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 mon_fsstatd \
		$(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 mon_fsstatd.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 mon_procd \
		$(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 mon_procd.8 \
		$(DESTDIR)$(MANDIR)/man8

clean:
	rm -f *.o *~ mon_fsstatd mon_procd core

.PHONY: all install clean

=== qethqoat/Makefile ===
include ../common.mak

all: qethqoat

qethqoat: qethqoat.o

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 qethqoat $(DESTDIR)$(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 qethqoat.8 $(DESTDIR)$(MANDIR)/man8

clean:
	rm -f *.o *~ qethqoat core

.PHONY: all install clean

=== scripts/Makefile ===
include ../common.mak

SCRIPTS	= dbginfo.sh zfcpdbf scsi_logging_level
MAN_PAGES = dbginfo.sh.1 zfcpdbf.1

all:

install:
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man1
	@for i in $(SCRIPTS); \
	do \
		cat $$i | \
		sed -e 's/%S390_TOOLS_VERSION%/$(S390_TOOLS_RELEASE)/' \
		>$(DESTDIR)$(BINDIR)/$$i; \
		chown $(OWNER):$(GROUP) $(DESTDIR)$(BINDIR)/$$i; \
		chmod 755 $(DESTDIR)$(BINDIR)/$$i; \
	done

	sed -e 's/%S390_TOOLS_VERSION%/$(S390_TOOLS_RELEASE)/' cpictl > \
		$(DESTDIR)$(TOOLS_LIBDIR)/cpictl
	chown $(OWNER):$(GROUP) $(DESTDIR)$(TOOLS_LIBDIR)/cpictl
	chmod 775 $(DESTDIR)$(TOOLS_LIBDIR)/cpictl

	@for i in $(MAN_PAGES); \
	do \
		$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 $$i \
		$(DESTDIR)$(MANDIR)/man1; \
	done

clean:

.PHONY: all install clean

=== debian/changelog ===
s390-tools (2.3.0-2~deb10u1) buster; urgency=medium

  * Upload debootstrap fix to Debian stable. (Closes: #960265)

 -- Philipp Kern <pkern@debian.org>  Mon, 17 Aug 2020 10:04:45 +0200

s390-tools (2.3.0-2) unstable; urgency=medium

  * Hardcode perl dependency instead of using ${perl:Depends}.
    The latter introduces a multi-arch dependency (perl:any) that the
    base installation environment cannot cope with.

 -- Philipp Kern <pkern@debian.org>  Sun, 16 Aug 2020 10:36:02 -0400

s390-tools (2.3.0-1) unstable; urgency=medium

  * New upstream release.
    - Drop debian/patches/zipl-no-pie.patch: applied upstream.
  * Add a watch file.
  * Package ziomon/ziorep reporting tools. (Closes: #812588)

 -- Philipp Kern <pkern@debian.org>  Sun, 04 Feb 2018 13:29:22 -0500

s390-tools (2.2.0-1) unstable; urgency=medium

  * New upstream release
    - Drop debian/patches/systemd-bindto.patch: applied upstream.
    - lsmem/chmem were moved to util-linux.
    - Ship upstream's changelog.

 -- Philipp Kern <pkern@debian.org>  Sun, 14 Jan 2018 15:36:29 +0100

s390-tools (1.37.1-1) unstable; urgency=medium

  * New upstream release
    - Pass in the default CPPFLAGS/LDFLAGS from debian/rules.
  * Drop the libsysfs-dev build-dependency; it is no longer used.
    (Closes: #856062)
  * Check for udevadm in /bin, not /sbin. (Closes: #852572)
  * Replace BindTo with BindsTo in systemd unit file. (Closes: #857190)

 -- Philipp Kern <pkern@debian.org>  Sun, 09 Jul 2017 10:07:15 +0200

=== debian/control ===
Source: s390-tools
Section: admin
Priority: important
Maintainer: Debian S/390 Team <debian-s390@lists.debian.org>
Uploaders: Bastian Blank <waldi@debian.org>, Philipp Kern <pkern@debian.org>
Build-Depends: debhelper (>> 9), libz-dev, quilt, gcc-multilib, libfuse-dev, libncurses-dev, libpfm4-dev
Standards-Version: 3.8.3
Homepage: http://www.ibm.com/developerworks/linux/linux390/s390-tools.html

Package: s390-tools
Architecture: s390x
Depends: ${shlibs:Depends}, ${misc:Depends}, perl, gawk
Recommends: sg3-utils
Description: Set of fundamental utilities for Linux on S/390
 The package contains:
  * dasdfmt, which is used to low-level format ECKD-DASDs with either
    the classic disk layout or the new zSeries compatible disk layout.
  * dasdview, which is used to display DASD and VTOC information or to
    dump the contents of a DASD to the console.
  * fdasd, which is used to create or modify partitions on ECKD-DASDs
    formatted with the zSeries compatible disk layout.
  * zipl, which is used to make either dasds or tapes bootable for
    system IPL or system dump.
  * zgetdump, which is used to retrieve system dumps from either tapes
    or dasds.

Package: s390-tools-udeb
XC-Package-Type: udeb
Section: debian-installer
Priority: optional
Architecture: s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Set of utilities for Linux on S/390
 This is a minimal package used by debian-installer.
 This package contains only the binaries dasdfmt and fdasd.

Package: ziomon
Priority: optional
Architecture: s390x
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, blktrace, rsync
Recommends: multipath-tools, lsscsi
Description: Performance analysis and reports for zFCP devices
 Tool set to collect data from zFCP devices for performance analysis
 and reporting.

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/<project>-$1\.tar\.gz/ \
  https://github.com/ibm-s390-tools/s390-tools/tags .*/v?(\d\S+)\.tar\.gz

## s390-tools 2.6.0

=== debian/changelog ===
s390-tools (2.6.0-0ubuntu7.3) cosmic; urgency=medium

  * Guard against needlesly resetting cpi vars. LP: #1805841
  * Use system path to find cryptsetup binary. LP: #1803958
  * Cherrypick upstream patch to add OSA-Express7S defines in
    qethqoat. LP: #1815022

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 02 May 2019 14:21:10 +0100

s390-tools (2.6.0-0ubuntu7.2) cosmic; urgency=medium

  * lsqeth: resolve core dump when called without any eth devices. LP:
    #1813888

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 13 Feb 2019 12:41:58 +0000

s390-tools (2.6.0-0ubuntu7.1) cosmic; urgency=medium

  * lszcrypt: Apply upstream patch to display bound driver name, if any,
    since the kernel supports alternate zcrypt drivers now. LP: #1800867

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 23 Jan 2019 11:56:12 +0000

s390-tools (2.6.0-0ubuntu7) cosmic; urgency=medium

  * zdev: Trigger generic_ccw devices on any kernel module loads. LP:
    #1794308

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 16 Oct 2018 10:23:35 +0100

s390-tools (2.6.0-0ubuntu6) cosmic; urgency=medium

  * Add a zkeyadm group, and make it own the default zkey repository
    directories. LP: #1794290
  * Cherrypick zdev initramfs hook rename
  * Cherrypick zkey initramfs hook LP: #1794346
  * Make zkey package activate update-initramfs trigger

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 02 Oct 2018 14:15:29 +0100

s390-tools (2.6.0-0ubuntu5) cosmic; urgency=medium

  * Cherrypick upstream patches for:
    - lstape, lsluns multiple paths fixes LP: #1790831
    - zkey documentation update
    - zfcpdump incompatible cast fix

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 05 Sep 2018 11:42:43 +0100

s390-tools (2.6.0-0ubuntu4) cosmic; urgency=medium

  * Add s390-tools-zkey-udeb package with zkey utilities for d-i. LP:
    #1766865

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 04 Sep 2018 16:58:09 +0100

s390-tools (2.6.0-0ubuntu3) cosmic; urgency=medium

  * Make initramfs-tools zdev hooks not conflict with zfs. LP: #1788314

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 22 Aug 2018 18:05:29 +0100

s390-tools (2.6.0-0ubuntu2) cosmic; urgency=medium

  * Add zdev initramfs hooks to initialize firmware provided devices by
    default. LP: #1776631

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 21 Aug 2018 15:06:21 +0100

s390-tools (2.6.0-0ubuntu1) cosmic; urgency=medium

  * New upstream release.
  * Add a zkey subpackage LP: #1786460.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 21 Aug 2018 14:29:58 +0100

s390-tools (2.5.0-0ubuntu1) cosmic; urgency=medium

  * New upstream release LP: #1776907 LP: #1775627 LP: #1775632
  * Drop udevadm patch, no longer needed
  * Refresh patches
  * Import upstream patches since v2.5.0 LP: #1777600

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 24 Jul 2018 17:00:03 +0100

s390-tools (2.3.0-0ubuntu4) cosmic; urgency=medium

  * No-change rebuild for ncurses soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 03 May 2018 14:18:56 +0000

s390-tools (2.3.0-0ubuntu3) bionic; urgency=medium

  * zz-zipl: Do not run if non-optional initrds don't exist yet (LP: #1766727)

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 25 Apr 2018 09:34:18 -0600

s390-tools (2.3.0-0ubuntu2) bionic; urgency=medium

  * Do not instead 60-readahead.rules, uses obsolete WAIT_FOR.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 28 Mar 2018 12:07:14 +0100

s390-tools (2.3.0-0ubuntu1) bionic; urgency=medium

  * New upstream release LP: #1746272

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 27 Feb 2018 10:49:21 +0000

s390-tools (2.2.0-0ubuntu1) bionic; urgency=medium

  * New upstream release.
  * Cherry-pick debian change:
    - Check for udevadm in /bin, not /sbin. (Closes: #852572)
  * Add watch file
  * Update copyright file
  * Do not use fail-missing, fails on conf-files

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 05 Jan 2018 11:09:26 +0000

=== debian/rules ===
--- 
+++ 
@@ -18,7 +18,8 @@
 	dh_install -ps390-tools-cpuplugd
 	dh_install -ps390-tools-statd
 	dh_install -ps390-tools-osasnmpd
-	dh_install -Xcpuplugd -Xosasnmpd -Xprocd -Xfsstatd --fail-missing
+	dh_install -ps390-tools-zkey -ps390-tools-zkey-udeb
+	dh_install -Xcpuplugd -Xosasnmpd -Xprocd -Xfsstatd -X60-readahead.rules -Xzkey
 
 override_dh_auto_clean:
 	dh_auto_clean -- $(options)
@@ -27,4 +28,4 @@
 	dh_auto_build -- $(options)
 
 override_dh_auto_install:
-	dh_auto_install -- $(options)
+	HAVE_INITRAMFS=1 HAVE_DRACUT=1 dh_auto_install -- $(options)

## s390-tools 2.8.0

=== Makefile ===
--- 
+++ 
@@ -3,12 +3,12 @@
 # Include common definitions
 include common.mak
 
-LIB_DIRS = libvtoc libu2s libutil libzds libdasd libvmdump libccw
+LIB_DIRS = libvtoc libu2s libutil libzds libdasd libvmdump libccw libvmcp
 TOOL_DIRS = zipl zdump fdasd dasdfmt dasdview tunedasd \
 	   tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf \
 	   vmconvert vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools \
 	   ziomon iucvterm hyptop cmsfs-fuse qethqoat zfcpdump zdsfs cpumf \
-	   systemd hmcdrvfs cpacfstats zdev dump2tar zkey netboot etc
+	   systemd hmcdrvfs cpacfstats zdev dump2tar zkey netboot etc zpcictl
 SUB_DIRS = $(LIB_DIRS) $(TOOL_DIRS)
 
 all: $(TOOL_DIRS)

=== libu2s/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 all: $(lib)
 
-objects = u2s.o misc.o
+objects = u2s.o
 
 $(lib): $(objects)

=== libutil/Makefile ===
--- 
+++ 
@@ -13,7 +13,8 @@
 		util_prg_example \
 		util_rec_example
 
-all: $(lib) $(examples)
+all: $(lib)
+examples: $(lib) $(examples)
 
 objects =	util_base.o \
 		util_path.o \

=== zconf/zcrypt/Makefile ===
include ../../common.mak

all: chzcrypt lszcrypt zcryptctl

libs = $(rootdir)/libutil/libutil.a

chzcrypt: chzcrypt.o misc.o $(libs)
lszcrypt: lszcrypt.o misc.o $(libs)
zcryptctl:  zcryptctl.o misc.o $(libs)

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 chzcrypt $(DESTDIR)$(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 lszcrypt $(DESTDIR)$(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 zcryptctl $(DESTDIR)$(BINDIR)
	$(INSTALL) -d -m 755 $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -m 644 -c chzcrypt.8 $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -m 644 -c lszcrypt.8 $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -m 644 -c zcryptctl.8 $(DESTDIR)$(MANDIR)/man8

clean:
	rm -f *.o chzcrypt lszcrypt zcryptctl

.PHONY: all install clean

=== zipl/src/Makefile ===
# Common definitions
include ../../common.mak

ALL_CPPFLAGS += -I../include -I../boot \
	    -DZFCPDUMP_IMAGE="STRINGIFY($(ZFCPDUMP_DIR)/$(ZFCPDUMP_IMAGE))" \
	    -DZFCPDUMP_INITRD="STRINGIFY($(ZFCPDUMP_DIR)/$(ZFCPDUMP_INITRD))" \
	    -D_FILE_OFFSET_BITS=64 $(NO_PIE_CFLAGS)
ALL_LDFLAGS += -Wl,-z,noexecstack $(NO_PIE_LDFLAGS)

libs =	$(rootdir)/libu2s/libu2s.a \
	$(rootdir)/libutil/libutil.a

objects = misc.o error.o scan.o job.o boot.o bootmap.o disk.o \
	  install.o zipl.o $(rootdir)/zipl/boot/data.o

zipl_helpers = $(basename $(wildcard zipl_helper.*.c))
chreipl_helpers = $(subst zipl_,chreipl_, $(zipl_helpers))

all: zipl $(chreipl_helpers)

zipl: $(objects) $(libs)

zipl_helper.device-mapper: $(rootdir)/libdasd/libdasd.a \
	$(rootdir)/libvtoc/libvtoc.a \
	$(libs) zipl_helper.device-mapper.o

chreipl_helper.%: zipl_helper.%
	ln -f -s $< $@

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR)
	$(INSTALL) -c zipl $(DESTDIR)$(BINDIR)
	$(INSTALL) -m 755 $(zipl_helpers) $(chreipl_helpers) \
		$(DESTDIR)$(TOOLS_LIBDIR)
	$(CP) --no-dereference $(chreipl_helpers) $(DESTDIR)$(TOOLS_LIBDIR)

clean:
	rm -f *.o $(zipl_helpers) $(chreipl_helpers) zipl

.PHONY: all install clean

# Additional manual dependencies

.boot.o.d boot.o: ../boot/data.h

../boot/data.h:
	make -C ../boot data.h

../boot/data.o:
	make -C ../boot data.o

=== debian/changelog ===
s390-tools (2.8.0-0ubuntu5) disco; urgency=medium

  * zkey: on Ubuntu, use default benchmarked Argon2i with LUKS2. LP:
    #1820049

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 15 Mar 2019 13:50:25 +0000

s390-tools (2.8.0-0ubuntu4) disco; urgency=medium

  * Guard against needlesly resetting cpi vars. LP: #1805841

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 13 Mar 2019 23:44:33 +0000

s390-tools (2.8.0-0ubuntu3) disco; urgency=medium

  * Import zkey bugfixes to support more cryptsetup options, and generate
    valid plain entries.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 07 Mar 2019 14:45:58 +0000

s390-tools (2.8.0-0ubuntu2) disco; urgency=medium

  * Restore missing history and, more importantly, the zz-zipl fix.

 -- Adam Conrad <adconrad@ubuntu.com>  Thu, 28 Feb 2019 10:54:06 -0700

s390-tools (2.8.0-0ubuntu1) disco; urgency=medium

  * New upstream release

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 21 Feb 2019 13:58:39 +0100

s390-tools (2.7.1-0ubuntu1) disco; urgency=medium

  * New upstream release:
    - zkey: Enhance error message about missing CCA library. LP: #1808520
    - Extended access controls for AP queue LP: #1804019
    - PCI error reporting tool LP: #1802499
    - zcrypt DD: introduce APQN tags to support deterministic driver
    binding LP: #1800867

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 15 Jan 2019 14:23:22 +0000

s390-tools (2.6.0-0ubuntu10) disco; urgency=medium

  * On Ubuntu, PATH is reset to a known secure path, when running programs
    as root, thus there is no need to reset PATH in zkey before calling
    system(). This fixes zkey failing to find cryptsetup. LP: #1803958

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 23 Nov 2018 02:45:09 +0000

s390-tools (2.6.0-0ubuntu9) disco; urgency=medium

  * No-change rebuild to fix wrong versioned dep on net-snmp.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 05 Nov 2018 13:25:09 -0800

s390-tools (2.6.0-0ubuntu8) disco; urgency=medium

  * zz-zipl: Handle removed-but-not-purged state by checking for zipl first.

 -- Adam Conrad <adconrad@ubuntu.com>  Mon, 05 Nov 2018 11:44:08 -0700

=== debian/control ===
Source: s390-tools
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian S/390 Team <debian-s390@lists.debian.org>
Uploaders: Bastian Blank <waldi@debian.org>, Philipp Kern <pkern@debian.org>
Build-Depends: debhelper (>> 9), libz-dev, quilt, gcc-multilib, libfuse-dev, libncurses-dev, libpfm4-dev, libsnmp-dev, dh-systemd, libssl-dev, libcryptsetup-dev, libjson-c-dev
Standards-Version: 3.9.7
Homepage: http://www.ibm.com/developerworks/linux/linux390/s390-tools.html

Package: s390-tools
Architecture: s390 s390x
Priority: important
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, gawk
Recommends: sg3-utils
Suggests: s390-tools-cpuplugd, s390-tools-osasnmpd, s390-tools-statd, multipath-tools, lsscsi, rsync, blktrace
Description: fundamental utilities for Linux on z Systems
 The package contains:
  * dasdfmt, which is used to low-level format ECKD-DASDs with either
    the classic disk layout or the new zSeries compatible disk layout.
  * dasdview, which is used to display DASD and VTOC information or to
    dump the contents of a DASD to the console.
  * fdasd, which is used to create or modify partitions on ECKD-DASDs
    formatted with the zSeries compatible disk layout.
  * zipl, which is used to make either dasds or tapes bootable for
    system IPL or system dump.
  * zgetdump, which is used to retrieve system dumps from either tapes
    or dasds.

Package: s390-tools-cpuplugd
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: cpuplugd utility for Linux on z Systems
 The package contains cpuplugd hotplug daemon from the s390-tools
 collection of utilities.

Package: s390-tools-statd
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: s390-tools (<<1.34.0-0ubuntu7~)
Replaces: s390-tools (<<1.34.0-0ubuntu7~)
Description: mon_statd monitoring daemons for Linux on z Systems
 The package contains mon_procd and mon_fsstatd z/VM monitoring
 daemons for Linux on z Systems from the s390-tools collection of
 utilities. These tools are also known as mon_statd.

Package: s390-tools-osasnmpd
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: osasnmpd utility for Linux on z Systems
 The package contains osasnmpd monitoring daemon from the s390-tools
 collection of utilities.

Package: s390-tools-zkey
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: zkey utilities for Linux on z Systems
 The package contains zkey and zkey-cryptsetup from the s390-tools
 collection of utilities.

Package: s390-tools-udeb
XC-Package-Type: udeb
Section: debian-installer
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: utilities for Linux on z Systems
 This is a minimal package used by debian-installer.
 This package contains only the binaries chzdev, lszdev, dasdfmt and
 fdasd.

Package: s390-tools-zkey-udeb
XC-Package-Type: udeb
Section: debian-installer
Priority: standard
Architecture: s390 s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: zkey utilities for Linux on z Systems
 The package contains zkey and zkey-cryptsetup from the s390-tools
 collection of utilities for the debian-installer

=== debian/rules ===
--- 
+++ 
@@ -14,7 +14,7 @@
 override_dh_install:
 	# no dracut
 	rm -f debian/tmp/lib/s390-tools/zdev-root-update
-	chmod -x debian/tmp/etc/*/*.conf debian/tmp/lib/s390-tools/zfcpdump/zfcpdump_part.rd
+	chmod -x debian/tmp/etc/*/*.conf debian/tmp/lib/s390-tools/zfcpdump/zfcpdump-initrd
 	dh_install -ps390-tools-cpuplugd
 	dh_install -ps390-tools-statd
 	dh_install -ps390-tools-osasnmpd

## s390-tools 2.11.0

=== zipl/boot/Makefile ===
# Common definitions
include ../../common.mak

CFLAGS_BOOT = $(NO_PIE_CFLAGS) -Os -g -I../include -D__ASSEMBLY__ \
	  -DS390_TOOLS_RELEASE=$(S390_TOOLS_RELEASE) \
	  -fno-builtin -ffreestanding -fno-asynchronous-unwind-tables \
	  -fno-delete-null-pointer-checks \
	  -fexec-charset=IBM1047 -m64 -mpacked-stack \
	  -mstack-size=4096 -mstack-guard=128 -msoft-float \
	  -W -Wall -Wformat-security

FILES	= fba0.bin fba1b.bin fba2.bin \
	  eckd0_ldl.bin eckd0_cdl.bin \
	  eckd1.bin eckd1b.bin eckd2.bin \
	  tape0.bin \
	  eckd2dump_sv.bin tape2dump.bin fba2dump.bin eckd2dump_mv.bin

all: data.o data.h tape0.bin stage3.bin

# Prevent make from using some default rules...
%:	%.S

%.o:	%.S
	$(CC) $(CFLAGS_BOOT) -c -o $@ $<

%.o:	%.c
	$(CC) $(CFLAGS_BOOT) -c -o $@ $<

eckd2dump_sv.exec: \
	head.o stage2dump.o cio.o eckd2dump.o eckd2dump_sv.o \
	libc.o sclp.o entry.o
eckd2dump_mv.exec: \
	head.o stage2dump.o cio.o eckd2dump.o eckd2dump_mv.o \
	libc.o sclp.o entry.o
fba2dump.exec: \
	head.o stage2dump.o cio.o fba2dump.o \
	libc.o sclp.o entry.o
tape2dump.exec: \
	head.o stage2dump.o cio.o tape2dump.o \
	libc.o sclp.o entry.o
eckd2.exec: head.o stage2.o cio.o eckd2.o libc.o menu.o sclp.o \
	    kdump2.o kdump.o entry.o
fba2.exec: head.o stage2.o cio.o fba2.o libc.o menu.o sclp.o \
	   kdump2.o kdump.o entry.o
stage3.exec: head.o stage3.o kdump3.o libc.o sclp.o sclp_stage3.o \
	     kdump.o entry.o stage3.lds

%.exec:	%.o
	STAGE=$$( \
		echo $@ | awk ' \
			match($$0,/[0-9]+b*/){ \
				print substr($$0,RSTART,RLENGTH) \
			}' \
	); \
	case $$STAGE in \
		0) SFLAGS="$(NO_PIE_LINKFLAGS) -nostdlib -Wl,-Ttext,0";; \
		1) SFLAGS="$(NO_PIE_LINKFLAGS) -nostdlib -Wl,-Ttext,0x18";; \
		1b) SFLAGS="$(NO_PIE_LINKFLAGS) -nostdlib -Wl,-Ttext,0xE000";; \
		2) SFLAGS="$(NO_PIE_LINKFLAGS) -nostdlib -Wl,-T,stage2.lds";; \
		3) SFLAGS="$(NO_PIE_LINKFLAGS) -nostdlib -Wl,-T,stage3.lds";; \
	esac; \
	$(LINK) $$SFLAGS -m64 $(filter %.o, $^) -o $@

%.bin:	%.exec
	$(OBJCOPY) -O binary \
		--only-section=.stage2.head \
		--only-section=.text.dummy \
		--only-section=.text.start \
		--only-section=.text \
		--only-section=.ex_table \
		--only-section=.data \
		--only-section=.rodata.str1.2 \
		--only-section=.rodata.cst8 \
		--only-section=.rodata \
		--only-section=.stage2dump.tail \
		--only-section=.eckd2dump_mv.tail \
		--only-section=.fixup \
		$< $@

stage3.bin:	stage3.exec
	$(OBJCOPY) -O binary \
		--only-section=.stage2.head \
		--only-section=.text.dummy \
		--only-section=.text.start \
		--only-section=.text \
		--only-section=.ex_table \
		--only-section=.data \
		--only-section=.rodata.str1.2 \
		--only-section=.rodata.cst8 \
		--only-section=.rodata \
		--only-section=.stage2dump.tail \
		--only-section=.eckd2dump_mv.tail \
		--only-section=.fixup \
		--pad-to=0xe000 \
		$< $@

data.o: $(FILES)
	$(LD) $(NO_PIE_LDFLAGS) -r -b binary -o data.o $(FILES)

data.h: data.o
	rm -f data.h
	$(NM) data.o | while read ADDR TYPE SYMBOL ; do \
				echo "extern char $$SYMBOL;" >>data.h; done

clean:
	rm -f *.o *.exec *.bin $(FILES) data.o data.h tape0.bin *.xxx *.yyy \
	      stage3.bin

.PHONY: all clean

=== debian/changelog ===
s390-tools (2.11.0-0ubuntu1) eoan; urgency=medium

  * New upstream release LP: #1830731
    - update from master snapshot, to v2.11.0 final
    - only minor bugfixes and clarifications included

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 10 Sep 2019 16:36:31 +0100

s390-tools (2.10.0-0ubuntu2) eoan; urgency=medium

  * Cherrypick patches from master since v2.10.0.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 19 Aug 2019 20:07:27 +0100

s390-tools (2.10.0-0ubuntu1) eoan; urgency=medium

  * New upstream release LP: #1836862, LP: #1836608

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 31 Jul 2019 23:43:34 -0400

s390-tools (2.9.0-0ubuntu4) eoan; urgency=medium

  * Rebuild against new libjson-c4.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 01 Jul 2019 15:02:17 +0200

s390-tools (2.9.0-0ubuntu3) eoan; urgency=medium

  * Fix FTBFS LP: #1833238

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 19 Jun 2019 14:28:12 +0100

s390-tools (2.9.0-0ubuntu2) eoan; urgency=medium

  * Add secure initial programme load signing. LP: #1829749

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 06 Jun 2019 13:20:45 +0100

s390-tools (2.9.0-0ubuntu1) eoan; urgency=medium

  * New upstream release

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 22 May 2019 21:19:21 +0100

s390-tools (2.8.0-0ubuntu6) eoan; urgency=medium

  * Cherrypick v2.9.0 patches.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 08 May 2019 20:15:17 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Package: s390-tools
 Architecture: s390 s390x
 Priority: important
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, gawk
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, ${signing:Depends}, gawk
 Recommends: sg3-utils
 Suggests: s390-tools-cpuplugd, s390-tools-osasnmpd, s390-tools-statd, multipath-tools, lsscsi, rsync, blktrace
 Description: fundamental utilities for Linux on z Systems
